OPAM-PIN(1)

NAME

opam-pin - Pin a given package to a specific version or source.

SYNOPSIS

opam pin [OPTION]... [COMMAND] [ARG]...

DESCRIPTION

This command allows local customisation of the packages in a given switch. A package can be pinned to a specific upstream version, to a path containing its source, to a version-controlled location or to a URL. If a file `NAME.opam' with NAME matching the package name, or just `opam', is found at the root of the pinned source, it will be used as the package's definition, overriding its previous definition if any. If a directory by one of these names is found, its contents will be used, also overriding other package metadata (`descr', extra `files' subdirectory...)

COMMANDS

Without argument, defaults to list.

list
    Lists pinned packages.

add PACKAGE TARGET
    Pins package PACKAGE to TARGET, which may be a version, a path, or a URL. PACKAGE can be omitted if TARGET is a local path containing a package description with a name. TARGET can be replaced by `--dev-repo' if a package by that name is already known. OPAM will infer the kind of pinning from the format of TARGET, using path pinning by default, unless you use an explicit --kind option. Pins to version control systems may target a specific branch or commit using #branch e.g. git://host/me/pkg#testing. When they don't, in the special case of version-controlled pinning to a local path, OPAM will use "mixed mode": it will only use version-controlled files, but at their current, on-disk version. If PACKAGE is not a known package name, a new package by that name will be locally created. The package version may be specified by using the format NAME.VERSION for PACKAGE, in the source opam file, or with edit.

remove NAMES
    Unpins packages NAMES, restoring their definition from the repository, if any.

edit NAME
    Opens an editor giving you the opportunity to change the opam file that OPAM will locally use for pinned package NAME, including its version. To simply change the pinning target, use add. The chosen editor is determined from environment variables OPAM_EDITOR, VISUAL or EDITOR, in order.

OPTIONS

--dev-repo
    Pin to the upstream package source for the latest development version

-e, --edit
    With opam pin add, edit the opam file as with `opam pin edit' after pinning.

-k KIND, --kind=KIND
    Sets the kind of pinning. Must be one of one of `version', `path', `http', `git', `darcs', `hg' or `auto'. If unset, is inferred from the format of the target, defaulting to path. If auto or OPAMPINKINDAUTO is set, a local path will be searched for version control and the pinning kind set accordingly. This is expected to become the default in a next version.

-n, --no-action
    Just record the new pinning status, and don't prompt for (re)installation or removal of affected packages.

-s, --short
    Output raw lists of names, one per line, skipping any details.

COMMON OPTIONS

These options are common to all commands.

--color=WHEN (absent=auto)
    Colorize the output. WHEN must be one of `always', `never' or `auto'.

--criteria=CRITERIA
    Specify user preferences for dependency solving for this run. Overrides both $OPAMCRITERIA and $OPAMUPGRADECRITERIA. For details on the supported language, and the external solvers available, see http://opam.ocaml.org/doc/Specifying_Solver_Preferences.html. A general guide to using solver preferences can be found at http://www.dicosmo.org/Articles/usercriteria.pdf. The default value is -count(down),-count(removed),-notuptodate(solution),-sum(solution,version-lag),-count(new) for upgrades, and -count(removed),-notuptodate(request),-sum(request,version-lag),-count(down),-notuptodate(changed),-count(changed),-notuptodate(solution),-sum(solution,version-lag) otherwise.

--cudf=FILENAME
    Debug option: Save the CUDF requests sent to the solver to FILENAME-<n>.cudf.

--debug
    Print debug message to stderr. This is equivalent to setting $OPAMDEBUG to "true".

--debug-level=LEVEL
    Like `--debug', but allows specifying the debug level (`--debug' sets it to 1). Equivalent to setting $OPAMDEBUG to a positive integer.

--git-version
    Print the git version if it exists and exit.

--help[=FMT] (default=pager)
    Show this help in format FMT (pager, plain or groff).

--no-base-packages
    Do not install base packages (useful for testing purposes). This is equivalent to setting $OPAMNOBASEPACKAGES to a non-empty string.

--no-self-upgrade
    OPAM will replace itself with a newer binary found at OPAMROOT/opam if present. This disables this behaviour.

-q, --quiet
    Be quiet when installing a new compiler.

--root=ROOT (absent=~/.opam)
    Use ROOT as the current root path. This is equivalent to setting $OPAMROOT to ROOT.

--safe
    Make sure nothing will be automatically updated or rewritten. Useful for calling from completion scripts, for example. Will fail whenever such an operation is needed ; also avoids waiting for locks, skips interactive questions and overrides the OPAMDEBUG variable.

--solver=CMD
    Specify the name of the external dependency solver. The default value is aspcud. Either 'aspcud', 'packup' or a custom command that may contain the variables %{input}%, %{output}% and %{criteria}%

--strict
    Fail whenever an error is found in a package definition or a configuration file. The default is to continue silently if possible.

--switch=SWITCH
    Use SWITCH as the current compiler switch. This is equivalent to setting $OPAMSWITCH to SWITCH.

--use-internal-solver, --no-aspcud
    Force use of internal heuristics, even if an external solver is available.

-v, --verbose
    Be more verbose, show package sub-commands and their output. Repeat to see more. Repeating n times is equivalent to setting $OPAMVERBOSE to "n".

--version
    Show version information.

-y, --yes
    Disable interactive mode and answer yes to all questions that would otherwise be asked to the user. This is equivalent to setting $OPAMYES to "true".

ENVIRONMENT VARIABLES

OPAM makes use of the environment variables listed here. Boolean variables should be set to "0", "no" of "false" to disable, "1", "yes" or "true" to enable.

OPAMCOLOR, when set to always or never, sets a default value for the --color option.

OPAMCRITERIA specifies user preferences for dependency solving.The default value is -count(removed),-notuptodate(request),-sum(request,version-lag),-count(down),-notuptodate(changed),-count(changed),-notuptodate(solution),-sum(solution,version-lag). See also option --criteria

OPAMCURL can be used to select a given 'curl' program. See OPAMFETCH for more options.

OPAMDEBUG see options `--debug' and `--debug-level'.

OPAMDOWNLOADJOBS sets the maximum number of simultaneous downloads.

OPAMEXTERNALSOLVER see option `--solver'.

OPAMFETCH specifies how to download files: either `wget', `curl' or a custom command where variables %{url}%, %{out}%, %{retries}%, %{compress}% and %{checksum}% will be replaced. Overrides the 'download-command' value from the main config file.

OPAMJOBS sets the maximum number of parallel workers to run.

OPAMLOCKRETRIES sets the number of tries after which OPAM gives up acquiring its lock and fails. <= 0 means infinite wait.

OPAMNO answer no to any question asked.

OPAMNOASPCUD see option `--no-aspcud'.

OPAMNOSELFUPGRADE see option `--no-self-upgrade'.

OPAMPINKINDAUTO if set, version control systems are detected when pinning to a local path.

OPAMREQUIRECHECKSUMS see option `--require-checksums'.

OPAMRETRY sets the number of tries before failing downloads.

OPAMROOT see option `--root'. This is automatically set by `opam config env --root=DIR' when DIR is non-default or OPAMROOT is already defined.

OPAMSAFE see option `--safe'

OPAMSKIPVERSIONCHECKS bypasses some version checks. Unsafe, for compatibility testing only.

OPAMSOLVERTIMEOUT change the time allowance of the internal solver.

OPAMSTATUSLINE display a dynamic status line showing what's currently going on on the terminal. (one of one of `always', `never' or `auto')

OPAMSWITCH see option `--switch'. Automatically set by `opam config env --switch=SWITCH'.

OPAMUPGRADECRITERIA specifies user preferences for dependency solving when performing an upgrade. Overrides OPAMCRITERIA in upgrades if both are set.The default value is -count(down),-count(removed),-notuptodate(solution),-sum(solution,version-lag),-count(new). See also option --criteria

OPAMUSEINTERNALSOLVER see option `--use-internal-solver'.

OPAMUTF8 use UTF8 characters in output (one of one of `always', `never' or `auto'). By default `auto', which is determined from the locale).

OPAMUTF8MSGS use extended UTF8 characters (camels) in OPAM messages. Implies OPAMUTF8. This is set by default on OSX only.

OPAMVAR_var overrides the contents of the variable var when substituting `%{var}%` strings in `opam` files.

OPAMVAR_package_var overrides the contents of the variable package:var when substituting `%{package:var}%` strings in `opam` files.

OPAMVERBOSE see option `--verbose'.

OPAMYES see option `--yes'.

FURTHER DOCUMENTATION

See https://opam.ocaml.org.

AUTHORS

Thomas Gazagnaire <thomas@gazagnaire.org>

Anil Madhavapeddy <anil@recoil.org>

Fabrice Le Fessant <Fabrice.Le_fessant@inria.fr>

Frederic Tuong <tuong@users.gforge.inria.fr>

Louis Gesbert <louis.gesbert@ocamlpro.com>

Vincent Bernardoff <vb@luminar.eu.org>

Guillem Rieu <guillem.rieu@ocamlpro.com>

Roberto Di Cosmo <roberto@dicosmo.org>

BUGS

Check bug reports at https://github.com/ocaml/opam/issues.